diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 81f67a35c..9930e1db5 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -495,10 +495,10 @@ public class Minecraft
         this.terrainRenderer = new TerrainRendererMultiDraw(this);
 
         setRenderer(new ShadersRenderer(this));
-        Shaders.init();
 
         TextureRegistry.init();
         this.texturePackList.init();
+        Shaders.init();
         EntityGeometryMojangData.Cache.reload(this.texturePackList);
 
         TooltipElement.reloadStyles(this.texturePackList);
@@ -1526,6 +1526,16 @@ public class Minecraft
                             displayInGameMenu();
                         } else if (GameSettings.KEY_COMMAND.isPressed()) {
                             displayScreen(new ScreenChat("/"));
+                        } else if (GameSettings.KEY_TOGGLE_FRAME_LIMIT.isPressEvent()) {
+                            if (GameSettings.ENABLE_VSYNC.value) {
+                                GameSettings.ENABLE_VSYNC.set(false);
+                                GameSettings.ENABLE_VSYNC.onUpdate();
+                                GameSettings.CUSTOM_FPS_LIMIT.set(0);
+                            } else {
+                                GameSettings.ENABLE_VSYNC.set(true);
+                                GameSettings.ENABLE_VSYNC.onUpdate();
+                                GameSettings.CUSTOM_FPS_LIMIT.set(0);
+                            }
                         } else {
                             checkBoundInputs(InputDevice.keyboard);
                         }
@@ -2322,7 +2332,7 @@ public class Minecraft
             if (spawnCoordinates != null) {
                 bedSpawnCoordinates = Player.getValidBedSpawnCoordinates(this.currentWorld, spawnCoordinates);
                 if (bedSpawnCoordinates == null) {
-                    this.thePlayer.sendTranslatedChatMessage("messages.bed.notValid");
+                    this.thePlayer.sendStatusMessageTranslated("messages.bed.notValid");
                 }
             }
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/Gui.java b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
index a5630757e..954bca89f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Gui.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
@@ -84,6 +84,24 @@ public class Gui {
         GLRenderer.popFrame();
     }
 
+    public void drawRect(@NotNull TessellatorGeneral t, int minX, int minY, int maxX, int maxY, final int argb) {
+        if (minX < maxX) {
+            final int temp = minX;
+            minX = maxX;
+            maxX = temp;
+        }
+        if (minY < maxY) {
+            final int temp = minY;
+            minY = maxY;
+            maxY = temp;
+        }
+        t.setColor1i(argb);
+        t.addVertex(minX, maxY, 0);
+        t.addVertex(maxX, maxY, 0);
+        t.addVertex(maxX, minY, 0);
+        t.addVertex(minX, minY, 0);
+    }
+
     public void drawRectDouble(double minX, double minY, double maxX, double maxY, final int argb) {
         if (minX < maxX) {
             final double temp = minX;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
index b8a039991..dad670792 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
@@ -65,11 +65,14 @@ public class ScreenConsole extends Screen {
                 this.scroll = 0;
             }
 
+            var font = Minecraft.getMinecraft().font;
+            font.startDrawingDeferred();
             final int lines = Math.min(heightLines, WORKED_LINES.size() - this.scroll);
             for (int i = lines - 1; i >= 0; i--) {
                 final @NotNull String line = WORKED_LINES.get((WORKED_LINES.size() - 1) - (i + this.scroll));
-                Minecraft.getMinecraft().font.render(line, x, y + getHeight(numLines) - LINE_HEIGHT - LINE_HEIGHT * i).setFont(Fonts.MONOSPACE).setColor(0xFF_CF_CF_CF).call();
+                font.render(line, x, y + getHeight(numLines) - LINE_HEIGHT - LINE_HEIGHT * i).setFont(Fonts.MONOSPACE).setColor(0xFF_CF_CF_CF).call();
             }
+            font.draw(this.zLevel);
             renderScrollIndicator(x, y, numLines);
         }
 
